<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Manual Digest Plugin 1.3                                                  |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// |                                                                           |
// | Main page of the Manual Digest plugin.                                    |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2003-2009 by the following authors:                         |
// |                                                                           |
// | Authors: Dirk Haun <dirk@haun-online.de>                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id: index.php,v 1.6 2009/03/08 15:01:59 dhaun Exp $

require_once('../../../lib-common.php');

if (!SEC_hasRights ('user.mail') && !SEC_hasRights ('user.edit')) {
    // Someone is trying to illegally access this page
    COM_accessLog ("Someone has tried to illegally access the Manual Digest index page. User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR", 1);
    $display = COM_siteHeader();
    $display .= COM_startBlock ($LANG_MDIGEST['access_denied']);
    $display .= $LANG_MDIGEST['access_denied_msg'];
    $display .= COM_endBlock ();
    $display .= COM_siteFooter ();
    echo $display;
    exit;
}

if (DB_getItem ($_TABLES['plugins'], 'pi_enabled', "pi_name='mdigest'") != 1) {
    echo COM_refresh ($_CONF['site_admin_url']);
    exit;
}

function send_digest ()
{
    global $_CONF, $_TABLES, $LANG_MDIGEST;

    $display = '';

    if ($_CONF['emailstories'] == 1) {
        if (isset ($_POST['sendit']) && !empty ($_POST['sendit'])) {
            COM_emailUserTopics ();
            $display .= '<p>' . $LANG_MDIGEST['digest_sent'] . '</p>' . LB;
        } else if (isset ($_POST['resetit']) && !empty ($_POST['resetit'])) {
            DB_query ("UPDATE {$_TABLES['vars']} SET value = NOW() WHERE name = 'lastemailedstories'");
            $display .= '<p>' . $LANG_MDIGEST['digest_reset'] . '</p>' . LB;
        } else {
            $display .= '<p>' . $LANG_MDIGEST['digest_intro'] . '</p>' . LB;
            $display .= '<p>' . $LANG_MDIGEST['explain_reset'] . '</p>' . LB;
            $lastrun = DB_getItem ($_TABLES['vars'], 'value', "name = 'lastemailedstories'");
            if (empty ($lastrun)) {
                $display .= '<p>' . $LANG_MDIGEST['digest_last_sent'] . ' ' . $LANG_MDIGEST['never'] . '</p>' . LB;
            } else {
                $display .= '<p>' . $LANG_MDIGEST['digest_last_sent'] . ' <b>' . $lastrun . '</b></p>' . LB;
            }

            $sql = "SELECT sid FROM {$_TABLES['stories']} WHERE draft_flag = 0 AND date <= NOW() AND date >= '{$lastrun}'";
            $result = DB_query ($sql);
            $count = DB_numRows ($result);
            if ($count == 0) {
                $display .= '<p>' . $LANG_MDIGEST['no_stories'] . '</p>' . LB;
            } else {
                $msg = sprintf ($LANG_MDIGEST['num_stories'], $count);
                $display .= '<p>' . $msg . '</p>' . LB;

                $display .= '<form action="' . $_SERVER['PHP_SELF'] . '" method="POST">' . LB;
                $display .= '<input type="submit" value="' . $LANG_MDIGEST['send_button'] . '" name="sendit">' . LB;
                $display .= ' &nbsp; <input type="submit" value="' . $LANG_MDIGEST['reset_button'] . '" name="resetit">' . LB;
                $display .= '</form>' . LB;
            }
    }
    } else {
        $display .= '<p>' . $LANG_MDIGEST['not_enabled1'] . '</p>' . LB;
        $display .= '<blockquote><code>$_CONF[\'emailstories\'] = 1;</code></blockquote>' . LB;
        $display .= '<p>' . $LANG_MDIGEST['not_enabled2'] . '</p>' . LB;
    }

    return $display;
}

function search_form ($query = '')
{
    global $_CONF, $LANG_MDIGEST;

    $display = '';

    $display .= '<form action="' . $_CONF['site_admin_url'] . '/plugins/mdigest/search.php" method="GET">' . LB;
    $display .= '<p>' . $LANG_MDIGEST['search_text'] . '</p>' . LB;
    $display .= '<input type="text" size="40" name="query" value="' . $query . '">' . LB;
    $display .= '<input type="submit" value="' . $LANG_MDIGEST['search_button'] . '">' . LB;
    $display .= '<input type="hidden" name="mode" value="search">' . LB;
    $display .= '</form>' . LB;

    return $display;
}


$display = COM_siteHeader ('menu');

if (SEC_hasRights ('user.mail')) {
    $display .= COM_startBlock ($LANG_MDIGEST['mdigest']);
    $display .= send_digest ();
    $display .= COM_endBlock();
}

if (SEC_hasRights ('user.edit')) {
    $display .= COM_startBlock ($LANG_MDIGEST['block_headline']);
    $display .= search_form ();
    $display .= COM_endBlock();
}

$display .= COM_siteFooter();

echo $display

?>
