<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Manual Digest Plugin 1.3                                                  |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// |                                                                           |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API method and 2) implements all the common code needed by the Manual     |
// | Digest PHP files.                                                         |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2003-2009 by the following authors:                         |
// |                                                                           |
// | Authors: Dirk Haun <dirk AT haun-online DOT de>                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id: functions.inc,v 1.5 2009/03/08 14:59:56 dhaun Exp $

$langfile = $_CONF['path'] . 'plugins/mdigest/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile)) 
{
    include ($langfile);
}
else 
{
    include ($_CONF['path'] . 'plugins/mdigest/language/english.php');
}


// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

function plugin_commentsupport_mdigest() 
{
    return false;
}

function plugin_cclabel_mdigest() 
{
    global $LANG_MDIGEST, $_CONF;

    if (SEC_hasRights ('user.mail')) {
        return array ($LANG_MDIGEST['mdigest'],
                      $_CONF['site_admin_url'] . '/plugins/mdigest/index.php',
                      plugin_geticon_mdigest());
    }

    return false;
}

function plugin_getadminoption_mdigest() 
{
    global $_CONF, $LANG_MDIGEST, $_TABLES;

    if (SEC_hasRights('user.mail')) {
        if ($_CONF['emailstories'] == 1) {
            $lastrun = DB_getItem ($_TABLES['vars'], 'value', "name = 'lastemailedstories'");
            $storysql = "SELECT sid FROM {$_TABLES['stories']} WHERE draft_flag = 0 AND date <= NOW() AND date >= '{$lastrun}'";
            $result = DB_query ($storysql);
            $count = DB_numRows ($result);
        } else {
            $count = 0;
        }

        return array ($LANG_MDIGEST['mdigest'],
                      $_CONF['site_admin_url'] . '/plugins/mdigest/index.php',
                      $count);
    }	
}

function plugin_geticon_mdigest ()
{
    global $_CONF;

    return $_CONF['site_admin_url'] . '/plugins/mdigest/images/mdigest.gif';
}

function plugin_chkVersion_mdigest ()
{
    return '1.3.1';
}

function plugin_upgrade_mdigest ()
{
    global $_TABLES;

    DB_query ("UPDATE {$_TABLES['plugins']} SET pi_version = '1.3.1', pi_homepage = 'http://geeklog.info/' WHERE pi_name = 'mdigest'");

    return true;
}

function plugin_uninstall_mdigest($steps = '')
{
    global $_TABLES;

    // Unregister the plugin with Geeklog
    // Always attempt to remove these entries or lib-common.php would still
    // try and read our functions.inc file ...
    COM_errorLog ('Attempting to unregister the plugin from Geeklog',1);
    DB_query ("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'mdigest'");
    DB_query ("DELETE FROM {$_TABLES['vars']} WHERE name = 'mdigest'");
    COM_errorLog ('...success',1);

    return true;
}

?>
